// DetailBoardDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DetailBoardDlg.h"

#include "afxdialogex.h"


// CDetailBoardDlg _CAO

IMPLEMENT_DYNAMIC(CDetailBoardDlg, CDialog)

CDetailBoardDlg::CDetailBoardDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDetailBoardDlg::IDD, pParent)
	, select_(0)
	, dlg_(board_)
{

}

CDetailBoardDlg::~CDetailBoardDlg()
{
}

void CDetailBoardDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TAB, m_xcTab);
}


BEGIN_MESSAGE_MAP(CDetailBoardDlg, CDialog)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB, &CDetailBoardDlg::OnTcnSelchangeTab)
END_MESSAGE_MAP()


// CDetailBoardDlg bZ[W nh[


BOOL CDetailBoardDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	auto bind = [this](const std::wstring& text, CDialog* dlg, int idd, int index, const boost::function<void()>& init)->bool{
		if (dlg == NULL) { return false; }
		dlg->Create(idd, this);
		dlg->SetParent(&m_xcTab);
		m_xcTab.InsertItem(index, text.c_str());

		Item item;
		item.dlg = dlg;
		item.index = index;
		item.init = init;
		vec_.push_back(item);

		return true;
	};

	bind(L"lbg[N", &dlg_.network, CDetailBoardNetworkDlg::IDD, 0, [this](){ dlg_.network.InitControls(); });
	bind(L"Xbh", &dlg_.thread, CDetailBoardThreadDlg::IDD, 1, [this](){ dlg_.thread.InitControls(); });
	bind(L"URLu", &dlg_.url, CDetailBoardURLDlg::IDD, 2, [this](){ dlg_.url.InitControls(); });
	bind(L"X{u", &dlg_.message, CDetailBoardMessageDlg::IDD, 3, [this](){ dlg_.message.InitControls(); });

	CRect rc;
	m_xcTab.GetWindowRect(&rc);
	m_xcTab.AdjustRect(FALSE, &rc);
	m_xcTab.ScreenToClient(&rc);
	for (auto it = vec_.begin(); it != vec_.end(); ++it)
	{
		if (::IsWindow(it->dlg->GetSafeHwnd()))
		{
			it->dlg->MoveWindow(rc);
		}
	}

	m_xcTab.SetCurSel(select_);
	OnTcnSelchangeTab(0, 0);
	m_xcTab.ModifyStyle(0, WS_CLIPCHILDREN);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDetailBoardDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CDetailBoardDlg::OnTcnSelchangeTab(NMHDR *pNMHDR, LRESULT *pResult)
{
	int sel = m_xcTab.GetCurSel();
	if (sel < 0) { if (pResult) { *pResult = 0; } }
	select_ = sel;
	
	for (auto it = vec_.begin(); it != vec_.end(); ++it)
	{
		if (it->index == sel)
		{
			it->dlg->ShowWindow(SW_SHOW);
		}
		else
		{
			it->dlg->ShowWindow(SW_HIDE);
		}
	}

	if (pResult) { *pResult = 0; }
}
