// DetailBoardMessageDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DetailBoardMessageDlg.h"
#include "afxdialogex.h"


// CDetailBoardMessageDlg _CAO

IMPLEMENT_DYNAMIC(CDetailBoardMessageDlg, CDialog)

//CDetailBoardMessageDlg::CDetailBoardMessageDlg(CWnd* pParent /*=NULL*/)
//	: CDialog(CDetailBoardMessageDlg::IDD, pParent)
//{
//
//}

CDetailBoardMessageDlg::CDetailBoardMessageDlg(sl::BoardConfig& board)
	: CDialog(CDetailBoardMessageDlg::IDD, NULL)
	, board_(board)
	, list_(board_.message)
	, m_xcList(list_, true)
{

}

CDetailBoardMessageDlg::~CDetailBoardMessageDlg()
{
}

void CDetailBoardMessageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST, m_xcList);
	DDX_Control(pDX, IDC_EDIT_DESC, m_xcEditDesc);
	DDX_Control(pDX, IDC_EDIT_REGEX, m_xcEditRegex);
	DDX_Control(pDX, IDC_EDIT_FORMAT, m_xcEditFormat);
}

void CDetailBoardMessageDlg::InitControls()
{
	int index = m_xcList.GetIndex();
	if (!list_.get(index, [this](const bbs::ReplaceElement& elem){
			EnableControls(TRUE);
			//--------------------------------
			m_xcEditDesc.SetWindowText(elem.desc.c_str());
			m_xcEditRegex.SetWindowText(elem.regex.c_str());
			m_xcEditFormat.SetWindowText(elem.format.c_str());
	}))
	{
		EnableControls(FALSE);
		//--------------------------------
		m_xcEditDesc.SetWindowText(L"");
		m_xcEditRegex.SetWindowText(L"");
		m_xcEditFormat.SetWindowText(L"");
	}
}

void CDetailBoardMessageDlg::EnableControls(BOOL enable)
{
	m_xcEditDesc.EnableWindow(enable);
	m_xcEditRegex.EnableWindow(enable);
	m_xcEditFormat.EnableWindow(enable);
}

BEGIN_MESSAGE_MAP(CDetailBoardMessageDlg, CDialog)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST, &CDetailBoardMessageDlg::OnLvnItemchangedList)
	ON_BN_CLICKED(IDC_BTN_ADD, &CDetailBoardMessageDlg::OnBnClickedBtnAdd)
	ON_BN_CLICKED(IDC_BTN_DEL, &CDetailBoardMessageDlg::OnBnClickedBtnDel)
	ON_BN_CLICKED(IDC_BTN_UP, &CDetailBoardMessageDlg::OnBnClickedBtnUp)
	ON_BN_CLICKED(IDC_BTN_DOWN, &CDetailBoardMessageDlg::OnBnClickedBtnDown)
	ON_EN_CHANGE(IDC_EDIT_DESC, &CDetailBoardMessageDlg::OnEnChangeEditDesc)
	ON_EN_CHANGE(IDC_EDIT_REGEX, &CDetailBoardMessageDlg::OnEnChangeEditRegex)
	ON_EN_CHANGE(IDC_EDIT_FORMAT, &CDetailBoardMessageDlg::OnEnChangeEditFormat)
	ON_BN_CLICKED(IDC_BTN_ALL_DEFAULT, &CDetailBoardMessageDlg::OnBnClickedBtnAllDefault)
END_MESSAGE_MAP()


// CDetailBoardMessageDlg bZ[W nh[


BOOL CDetailBoardMessageDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_xcList.InsertColumn(0, L"", LVCFMT_LEFT, 30);
	m_xcList.InsertColumn(1, L"", LVCFMT_LEFT, 115);
	m_xcList.InsertColumn(2, L"K\", LVCFMT_LEFT, 115);
	m_xcList.InsertColumn(3, L"uK", LVCFMT_LEFT, 115);

	InitControls();

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDetailBoardMessageDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CDetailBoardMessageDlg::OnLvnItemchangedList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	
	InitControls();

	if (pResult) { *pResult = 0; }
}

void CDetailBoardMessageDlg::OnBnClickedBtnAdd()
{
	m_xcList.AddItem();
	InitControls();
}


void CDetailBoardMessageDlg::OnBnClickedBtnDel()
{
	m_xcList.DelItem();
	InitControls();
}


void CDetailBoardMessageDlg::OnBnClickedBtnUp()
{
	m_xcList.UpItem();
	InitControls();
}


void CDetailBoardMessageDlg::OnBnClickedBtnDown()
{
	m_xcList.DownItem();
	InitControls();
}


void CDetailBoardMessageDlg::OnEnChangeEditDesc()
{
	if (!IsWindow(m_xcEditDesc.GetSafeHwnd())) { return; }

	int index = m_xcList.GetIndex();
	if (list_.get(index, [this](bbs::ReplaceElement& elem) {
		CString str;
		m_xcEditDesc.GetWindowText(str);
		elem.desc = std::wstring(str);
	}))
	{
		m_xcList.Update(index);
	}
}


void CDetailBoardMessageDlg::OnEnChangeEditRegex()
{
	if (!IsWindow(m_xcEditRegex.GetSafeHwnd())) { return; }

	int index = m_xcList.GetIndex();
	if (list_.get(index, [this](bbs::ReplaceElement& elem) {
		CString str;
		m_xcEditRegex.GetWindowText(str);
		elem.regex = std::wstring(str);
	}))
	{
		m_xcList.Update(index);
	}
}


void CDetailBoardMessageDlg::OnEnChangeEditFormat()
{
	if (!IsWindow(m_xcEditFormat.GetSafeHwnd())) { return; }

	int index = m_xcList.GetIndex();
	if (list_.get(index, [this](bbs::ReplaceElement& elem) {
		CString str;
		m_xcEditFormat.GetWindowText(str);
		elem.format = std::wstring(str);
	}))
	{
		m_xcList.Update(index);
	}
}


void CDetailBoardMessageDlg::OnBnClickedBtnAllDefault()
{
	auto tmp = sl::BoardConfig();
	board_.message = tmp.message;
	m_xcList.Init();
	m_xcList.RedrawWindow();
	InitControls();
}

