// StatusDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "StatusDlg.h"
//#include "afxdialogex.h"


enum TIMER_ID {
	TIMER_ID_UPDATE,
	TIMER_ID_SLIDER,
};

#define SLIDER_MARGIN 10


CRect StatusLayoutManager::nameRect(const CRect& src)
{
	CRect rc(src);
	int right = rightPos(rc);
	rc.right = min(rc.left + (name.width), rc.right);
	rc.left = min(rc.left, right);
	rc.right = min(rc.right, right);
	return rc;
}

CRect StatusLayoutManager::textRect(const CRect& src)
{
	CRect rc(src);
	int right = rightPos(rc);
	rc.left = min(rc.left + (name.width), rc.right);
	rc.right = min(rc.left + (text.width), rc.right);
	rc.left = min(rc.left, right);
	rc.right = min(rc.right, right);
	return rc;
}

CRect StatusLayoutManager::bitrateRect(const CRect& src)
{
	CRect rc(src);
	int right = rightPos(rc);
	rc.left = min(rc.left + (name.width + text.width), rc.right);
	rc.right = min(rc.left + (bitrate.width), rc.right);
	rc.left = min(rc.left, right);
	rc.right = min(rc.right, right);
	return rc;
}

CRect StatusLayoutManager::fpsRect(const CRect& src)
{
	CRect rc(src);
	int right = rightPos(rc);
	rc.left = min(rc.left + (name.width + text.width + bitrate.width), rc.right);
	rc.right = min(rc.left + (fps.width), rc.right);
	rc.left = min(rc.left, right);
	rc.right = min(rc.right, right);
	return rc;
}

CRect StatusLayoutManager::sizeRect(const CRect& src)
{
	CRect rc(src);
	rc.right = max(rc.right - (volume.width + slider.width + time.width), rc.left);
	rc.left = max(rc.right - (size.width), rc.left);
	return rc;
}

CRect StatusLayoutManager::timeRect(const CRect& src)
{
	CRect rc(src);
	rc.right = max(rc.right - (volume.width + slider.width), rc.left);
	rc.left = max(rc.right - (time.width), rc.left);
	return rc;
}

CRect StatusLayoutManager::sliderRect(const CRect& src)
{
	CRect rc(src);
	rc.right = max(rc.right - (volume.width), rc.left);
	rc.left = max(rc.right - (slider.width), rc.left);
	return rc;
}

CRect StatusLayoutManager::volumeRect(const CRect& src)
{
	CRect rc(src);
	rc.left = max(rc.right - (volume.width), rc.left);
	return rc;
}

CRect StatusLayoutManager::volumeSliderRect(const CRect& src)
{
	CRect rc(src);
	rc.left = max(rc.right - (volume.width + slider.width), rc.left);
	return rc;
}


int StatusLayoutManager::rightPos(const CRect& src)
{
	return max(src.right - (time.width + volume.width + slider.width + size.width), src.left);
}


// CStatusDlg _CAO

IMPLEMENT_DYNAMIC(CStatusDlg, CDialog)

CStatusDlg::CStatusDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStatusDlg::IDD, pParent)
	, height_(16)
	, click_(false)
	, capture_(false)
	, show_(false)
{
	utl::createFont(font_);
}

CStatusDlg::~CStatusDlg()
{
	if (font_.GetSafeHandle()) { font_.DeleteObject(); }
}

void CStatusDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


void CStatusDlg::SetConfig(const sl::StatusConfig& cfg)
{
	layout_.bitrate.width = 0;
	layout_.fps.width = 0;

	cfg_ = cfg;
	font_.DeleteObject();
	font_.CreateFontIndirect(&cfg_.font);

	height_ = utl::getFontHeight(GetSafeHwnd(), font_) + (cfg_.marginY * 2);
}

void CStatusDlg::setDesc(const std::wstring& desc)
{
	desc_ = desc;
}

void CStatusDlg::clearDesc()
{
	desc_.clear();
}

BEGIN_MESSAGE_MAP(CStatusDlg, CDialog)
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSELEAVE()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_RBUTTONDBLCLK()
END_MESSAGE_MAP()


// CStatusDlg bZ[W nh[


BOOL CStatusDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// \ɌȂ悤ɂ
	SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOACTIVATE);

	// qg_CAO
	if (channel_.GetSafeHwnd())
	{
		channel_.DestroyWindow();
	}

	channel_.Create(CChannelDlg::IDD, this);
	channel_.SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOZORDER|SWP_NOACTIVATE);
	channel_.setAlign(DT_LEFT);

	std::wstring text;
	gl_.peca.getInfo(text);
	channel_.setText(text);

	// 
	layout_.name.type = gl_.value.format.name.type;
	layout_.bitrate.type = gl_.value.format.bitrate.type;
	layout_.fps.type = gl_.value.format.fps.type;
	layout_.size.type = gl_.value.format.size.type;
	layout_.time.type = gl_.value.format.time.type;

	layout_.name.enable = gl_.value.format.name.enable;
	layout_.bitrate.enable = gl_.value.format.bitrate.enable;
	layout_.fps.enable = gl_.value.format.fps.enable;
	layout_.size.enable = gl_.value.format.size.enable;
	layout_.time.enable = gl_.value.format.time.enable;

	layout_.volume.enable = gl_.value.format.volume.enable;
	layout_.slider.enable = false; // Ԃ͉B

	SetTimer(TIMER_ID_UPDATE, 100, NULL); // XVp^C}[

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CStatusDlg::PreTranslateMessage(MSG* pMsg)
{
	switch (pMsg->message)
	{
	case WM_KEYDOWN:
	case WM_SYSKEYDOWN:
		return FALSE;
	}
	return CDialog::PreTranslateMessage(pMsg);
}


BOOL CStatusDlg::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
	//return CDialog::OnEraseBkgnd(pDC);
}




bool CStatusDlg::statusRight(CDC& dc, const RECT& target, int& right)
{
	CRect calc;
	bool online = gl_.player.online();

	// {[
	CString volume;
	{
		if (gl_.value.audio.mute)
		{
			volume = L"---";
		}
		else
		{
			int vol = gl_.value.audio.volume;
			vol = max(vol, 0);
			vol = min(vol, 100);
			volume.Format(L"%d", vol);
		}
	}
	dc.DrawText(L"0000", -1, &calc, DT_CALCRECT|DT_NOPREFIX|DT_SINGLELINE|DT_RIGHT|DT_VCENTER);
	layout_.volume.width = max(layout_.volume.width, calc.Width());

	// XC_[
	if (layout_.slider.enable)
	{
		layout_.slider.width = 70; // XC_[

		// 쐫̂ߍEɗ]
		CRect rc(target);
		rc.left = max(rc.left, rc.right - (layout_.volume.width + (layout_.slider.width - SLIDER_MARGIN)));
		rc.right = max(rc.left, rc.right - (layout_.volume.width + SLIDER_MARGIN));

		int per = gl_.value.audio.volume;
		int pos = (int)((double)rc.Width() * ((double)per / 100.0));
		utl::drawSlider(dc, rc, pos);
	}
	else
	{
		layout_.slider.width = 0;
	}

	// ^C
	CString time;
	if (online)
	{// IC݈͌ʒû
		LONGLONG cur = 0;
		if (gl_.player.getCurrentPosition(cur))
		{
			time.Format(L" %s", utl::convertTimes(cur).c_str());
		}
		else
		{
			layout_.time.width = 0;
		}
	}
	else
	{
		LONGLONG cur = 0, dur = 0;
		if (gl_.player.getCurrentPosition(cur) && gl_.player.getDuration(dur))
		{
			switch (layout_.time.type)
			{
			case 0:
			default:
				time.Format(L" %s / %s", utl::convertTimes(cur, false).c_str(), utl::convertTimes(dur, false).c_str());
				break;

			case 1:
				cur = dur - cur;
				time.Format(L" -%s / %s", utl::convertTimes(cur, false).c_str(), utl::convertTimes(dur, false).c_str());
				break;
			}
		}
		else
		{
			layout_.time.width = 0;
		}
	}
	dc.DrawText(time, -1, &calc, DT_CALCRECT|DT_NOPREFIX|DT_SINGLELINE|DT_RIGHT|DT_VCENTER);
	layout_.time.width = calc.Width();


	// TCY
	CString size;
	if (gl_.value.window.status.size)
	{
		CSize native;
		if (gl_.player.getNativeVideoSize(native))
		{
			switch (layout_.size.type)
			{
			case 0:
			default:
				{
					CRect main;
					reinterpret_cast<CSubpaneDlg*>(GetParent())->getVideoRect(main);
					size.Format(L" (%dx%d)", main.Width(), main.Height());
					break;
				}

			case 1:
				{
					size.Format(L" (%dx%d)", native.cx, native.cy);
					break;
				}

			case 2:
				{
					CRect main;
					reinterpret_cast<CSubpaneDlg*>(GetParent())->getVideoRect(main);
					size.Format(L" (%dx%d/%dx%d)", main.Width(), main.Height(), native.cx, native.cy);
					break;
				}
			}
		}
		else
		{
			CRect main;
			reinterpret_cast<CSubpaneDlg*>(GetParent())->getVideoRect(main);
			size.Format(L" (%dx%d)", main.Width(), main.Height());
		}
		dc.DrawText(size, -1, &calc, DT_CALCRECT|DT_NOPREFIX|DT_SINGLELINE|DT_RIGHT|DT_VCENTER);
		layout_.size.width = calc.Width();
	}
	else
	{
		layout_.size.width = 0;
	}




	{
		CRect rc(target);

		// {[
		dc.DrawText(volume, -1, &rc, DT_NOPREFIX|DT_SINGLELINE|DT_RIGHT|DT_VCENTER);
	}

	{
		CRect rc(target);

		// ^C
		rc.right = max(rc.left, rc.right - (layout_.volume.width + layout_.slider.width));
		dc.DrawText(time, -1, &rc, DT_NOPREFIX|DT_SINGLELINE|DT_RIGHT|DT_VCENTER);
	}


	{
		CRect rc(target);

		// TCY
		rc.right = max(rc.left, rc.right - (layout_.volume.width + layout_.slider.width + layout_.time.width));
		dc.DrawText(size, -1, &rc, DT_NOPREFIX|DT_SINGLELINE|DT_RIGHT|DT_VCENTER);
	}




	right = layout_.volume.width + layout_.slider.width + layout_.time.width + layout_.size.width;
	return true;
}

// right ͉EXe[^X̕statusRightŎ擾l
// ߂Ƃ̏Ɏg
bool CStatusDlg::statusLeft(CDC& dc, const RECT& target, int left, int right)
{
	bool online = gl_.player.online();

	if (!online)
	{
		layout_.bitrate.width = 0;
		layout_.fps.width = 0;

		CString text;
		long state = State_Stopped;
		if (gl_.player.getState(0, state))
		{
			switch (state)
			{
			case State_Running:
				text = L"Đ ";
				break;

			case State_Paused:
				text = L"ꎞ~ ";
				break;

			case State_Stopped:
			default:
				return false;
			}
		}

		CRect calc, rc(target);
		rc.left = rc.left + left;
		rc.right = max(rc.left, rc.right - right);
		dc.DrawText(text, -1, &rc, DT_NOPREFIX|DT_SINGLELINE|DT_LEFT|DT_VCENTER|DT_END_ELLIPSIS);
		dc.DrawText(text, -1, &calc, DT_CALCRECT|DT_NOPREFIX|DT_SINGLELINE|DT_LEFT|DT_VCENTER);
		layout_.text.width = calc.Width();

		if (state == State_Running)
		{
			if (gl_.value.window.status.fps)
			{
				statusLeft2(dc, target, left + layout_.text.width, right);
			}
		}
		return false;
	}

	CRect calc, rc(target);
	// rbg[g
	CString bitrate;

	int fix = 0;
	int crate = 0, rate = 0;
	if (gl_.player.getCurrentBitrate(crate))
	{
		if (gl_.player.peercast())
		{
			gl_.peca.getBitrate(rate);
			switch (layout_.bitrate.type)
			{
			case 0:
			default:
				bitrate.Format(L"%d kbps ", crate);
				break;
			case 1:
				bitrate.Format(L"%d kbps ", rate);
				break;
			case 2:
				bitrate.Format(L"%d/%d kbps ", crate, rate);
				break;
			case 3:
				{
					int tmp = 0;
					if (rate > 0)
					{
						tmp = utl::lround(((double)crate * 100.0) / (double)rate);
					}
					bitrate.Format(L"%d %% ", tmp);
					break;
				}
			}
		}
		else
		{
			bitrate.Format(L"%d kbps ", crate);
		}

		dc.DrawText(bitrate, -1, &calc, DT_CALCRECT|DT_NOPREFIX|DT_SINGLELINE|DT_LEFT|DT_VCENTER);

		if (layout_.bitrate.type != layout_.bitrate.old)
		{// tH[}bgς̂ŃCfgZbg
			layout_.bitrate.width = 0;
			layout_.bitrate.old = layout_.bitrate.type;
		}

		layout_.bitrate.width = max(layout_.bitrate.width, calc.Width());
		fix = layout_.bitrate.width - calc.Width();

		// rbg[g
		rc.left = rc.left + left + fix;
		rc.right = max(rc.left, rc.right - right);
		dc.DrawText(bitrate, -1, &rc, DT_NOPREFIX|DT_SINGLELINE|DT_LEFT|DT_VCENTER|DT_END_ELLIPSIS);
	}
	else
	{
		layout_.bitrate.width = 0;
	}



	int per = 0;
	
	if (gl_.player.getProgress(per))
	{
		bitrate.Format(L"obt@ (%d%%)", per);

		CRect rc(target);
		rc.left = rc.left + left + layout_.bitrate.width;
		rc.right = max(rc.left, rc.right - right);
		dc.DrawText(bitrate, -1, &rc, DT_NOPREFIX|DT_SINGLELINE|DT_LEFT|DT_VCENTER|DT_END_ELLIPSIS);

		layout_.fps.width = 0;//NbNNA
		return true;
	}
	else
	{
		statusLeft2(dc, target, left + layout_.bitrate.width, right);
	}

	return true;
}

bool CStatusDlg::statusLeft2(CDC& dc, const RECT& target, int left, int right)
{
	CRect calc, rc(target);

	int fix = 0;
	CString fps;
	{
		int frame = 0, cframe = 0;
		if (gl_.player.getCurrentFramerate(cframe) && gl_.player.getFramerate(frame))
		{
			switch (layout_.fps.type)
			{
			case 0:
			default:
				fps.Format(L"(%d) ", utl::lround((double)cframe / 100.0));
				break;

			case 1:
				fps.Format(L"(%.2f) ", (double)cframe / 100.0);
				break;

			case 2:
				fps.Format(L"(%d/%d) ", utl::lround((double)cframe / 100.0), utl::lround((double)frame / 100.0));
				break;

			case 3:
				fps.Format(L"(%.2f/%.2f) ", (double)cframe / 100.0, (double)frame / 100.0);
				break;
			}

			dc.DrawText(fps, -1, &calc, DT_CALCRECT|DT_NOPREFIX|DT_SINGLELINE|DT_LEFT|DT_VCENTER);

			if (layout_.fps.type != layout_.fps.old)
			{// tH[}bgς̂ŃCfgZbg
				layout_.fps.width = 0;
				layout_.fps.old = layout_.fps.type;
			}

			layout_.fps.width = max(layout_.fps.width, calc.Width());
			fix = layout_.fps.width - calc.Width();
		}
		else
		{
			layout_.fps.width = 0;
		}
	}

	rc.left = rc.left + left + fix;
	rc.right = max(rc.left, rc.right - right);
	dc.DrawText(fps, -1, &rc, DT_NOPREFIX|DT_SINGLELINE|DT_LEFT|DT_VCENTER|DT_END_ELLIPSIS);

	return true;
}


bool CStatusDlg::getChannelStatusText(std::wstring& text)
{
	if (!gl_.player.peercast())
	{
		if (!nametext_.empty())
		{// `l()
			text = nametext_ + L" ";
			return true;
		}
		return false;
	}

	network::ChannelInfo info;
	gl_.peca.getInfo(info);

	std::wstring name;
	if (gl_.value.window.status.channel.name)
	{
		if (!nametext_.empty())
		{// `l()
			name = nametext_ + L" ";
		}
		else
		{
			gl_.peca.getName(name);
			if (!name.empty())
			{
				name = name + L" ";
			}
		}
	}

	std::wstring type;
	if (gl_.value.window.status.channel.type)
	{
		if (!info.type.empty())
		{
			type = L"(" + info.type + L") ";
		}
	}

	std::wstring genre;
	if (gl_.value.window.status.channel.genre)
	{
		if (!info.cnv.genreDesc.empty())
		{
			genre = L"[" + info.cnv.genreDesc + L"] ";
		}
	}

	std::wstring comment;
	if (gl_.value.window.status.channel.comment)
	{
		if (!info.comment.empty())
		{
			comment = L"u" + info.comment + L"v ";
		}
	}

	std::wstring playing;
	if (gl_.value.window.status.channel.playing)
	{
		if (!info.cnv.playing.empty())
		{
			playing = info.cnv.playing + L" ";
		}
	}

	CString relay;
	if (gl_.value.window.status.channel.relay)
	{
		relay.Format(L"[%d/%d] ", info.cnv.listeners, info.cnv.relays);
	}

	if (info.id.empty())
	{// idȂ̂Ŏ擾s
		text = name;
	}
	else
	{
		text = name + type + genre + comment + playing + std::wstring(relay);
	}
	return true;
}

void CStatusDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: ɃbZ[W nh[ R[hǉ܂B
	// `惁bZ[W CDialog::OnPaint() ĂяoȂłB

	CRect org;
	GetClientRect(&org);

	CDC memDC;
	memDC.CreateCompatibleDC(&dc);

	CBitmap bmp;
	bmp.CreateCompatibleBitmap(&dc, org.Width(), org.Height());
	CBitmap* oldBmp = memDC.SelectObject(&bmp);
	CFont* oldFont = memDC.SelectObject(&font_);

	///////////////////////////////////////////////////////////////
	memDC.SetTextColor(cfg_.text[0]);
	memDC.SetBkColor(RGB(0, 0, 0));
	memDC.SetBkMode(TRANSPARENT);
	
	// wi
	utl::drawStatusBar(memDC, &org, cfg_.color);

	CRect rc(org);
	// Cfg
	rc.DeflateRect(cfg_.marginX, 0, cfg_.marginX, 0);

	// E[
	int right = 0;
	statusRight(memDC, rc, right);

	// [
	// `l
	if (desc_.empty())
	{
		std::wstring name;
		if (getChannelStatusText(name))
		{
			CRect tmp(rc), calc;
			tmp.right = max(tmp.left, tmp.right - right);
			memDC.DrawText(name.c_str(), -1, &tmp, DT_NOPREFIX|DT_SINGLELINE|DT_LEFT|DT_VCENTER|DT_END_ELLIPSIS);
			memDC.DrawText(name.c_str(), -1, &calc, DT_CALCRECT|DT_NOPREFIX|DT_SINGLELINE|DT_LEFT|DT_VCENTER);
			layout_.name.width = calc.Width();
		}
		else
		{
			layout_.name.width = 0;
		}

		std::wstring text;
		if (gl_.player.getStatusText(text))
		{// vC[eLXg
			CRect tmp(rc);
			tmp.left = tmp.left + layout_.name.width;
			tmp.right = max(tmp.left, tmp.right - right);
			memDC.DrawText(text.c_str(), -1, &tmp, DT_NOPREFIX|DT_SINGLELINE|DT_LEFT|DT_VCENTER|DT_END_ELLIPSIS);
		
			layout_.text.width = 0;
			layout_.bitrate.width = 0;
			layout_.fps.width = 0;
		}
		else
		{
			layout_.text.width = 0;
			statusLeft(memDC, rc, layout_.name.width, right);
		}
	}
	else
	{
		CRect tmp(rc);
		tmp.left = tmp.left;
		tmp.right = max(tmp.left, tmp.right - right);
		memDC.DrawText(desc_.c_str(), -1, &tmp, DT_NOPREFIX|DT_SINGLELINE|DT_LEFT|DT_VCENTER|DT_END_ELLIPSIS);

		layout_.name.width = 0;
		layout_.text.width = 0;
	}



	///////////////////////////////////////////////////////////////
	dc.BitBlt(0, 0, org.Width(), org.Height(), &memDC, 0, 0, SRCCOPY);
	memDC.SelectObject(oldFont);
	memDC.SelectObject(oldBmp);
	bmp.DeleteObject();
}



void CStatusDlg::OnTimer(UINT_PTR nIDEvent)
{
	switch (nIDEvent)
	{
	case TIMER_ID_UPDATE:
		{// XV
			if (!IsWindowVisible()) { break; }
			Invalidate(FALSE);
			break;
		}
	case TIMER_ID_SLIDER:
		{// XC_[x
			layout_.slider.enable = false;
			Invalidate(FALSE);
			KillTimer(TIMER_ID_SLIDER);
			break;
		}
	}

	CDialog::OnTimer(nIDEvent);
}


void CStatusDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	Invalidate(FALSE);
}

void CStatusDlg::SetMouseHover()
{
	// }EXĎJn(OnMouseLeave)
	TRACKMOUSEEVENT tme;
	tme.cbSize = sizeof(tme);
	tme.dwFlags = TME_LEAVE;
	tme.hwndTrack = GetSafeHwnd();
	tme.dwHoverTime = HOVER_DEFAULT;
	TrackMouseEvent(&tme);
}

void CStatusDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	CRect org;
	GetClientRect(org);

	CRect rect(org);
	rect.DeflateRect(cfg_.marginX, 0);

	if (capture_)
	{// XC_[
		// XC_[vZ
		CRect rc(rect);
		rc.left = rc.right - (layout_.volume.width + layout_.slider.width);
		rc.left += SLIDER_MARGIN;
		rc.right = rc.right - (layout_.volume.width + SLIDER_MARGIN);
		int width = rc.Width();

		// müʒu
		int pos = point.x - rc.left;
		pos = max(pos, 0);
		pos = min(pos, width);

		if (width > 0)
		{// ʓKp/~[g
			int vol = (int)(((double)pos / (double)width)*100.0);
			
			gl_.value.audio.mute = false;
			gl_.player.setMute(false);
			gl_.value.audio.volume = vol;
			gl_.player.setVolume(vol);

			Invalidate(FALSE);
			UpdateWindow();
		}
		return;
	}

	
	{// {[&XC_[
		if (layout_.volumeSliderRect(rect).PtInRect(point))
		{
			if (layout_.volume.enable)
			{// XC_[\
				KillTimer(TIMER_ID_SLIDER);// x^C}[Zbg
				layout_.slider.enable = true;
			}

			SetCursor(LoadCursor(NULL, IDC_HAND));
			SetMouseHover();
			return;
		}
	}

	if (!gl_.value.window.status.fixed)
	{
		if (layout_.time.enable)
		{// ^C
			if (layout_.timeRect(rect).PtInRect(point))
			{
				SetCursor(LoadCursor(NULL, IDC_HAND));
				SetMouseHover();
				return;
			}
		}

		if (layout_.size.enable)
		{// TCY
			if (layout_.sizeRect(rect).PtInRect(point))
			{
				SetCursor(LoadCursor(NULL, IDC_HAND));
				SetMouseHover();
				return;
			}
		}

		if (layout_.bitrate.enable)
		{// bitrate
			if (layout_.bitrateRect(rect).PtInRect(point))
			{
				SetCursor(LoadCursor(NULL, IDC_HAND));
				SetMouseHover();
				return;
			}
		}

		if (layout_.fps.enable)
		{// fps
			if (layout_.fpsRect(rect).PtInRect(point))
			{
				SetCursor(LoadCursor(NULL, IDC_HAND));
				SetMouseHover();
				return;
			}
		}
	}

	{// `l
		if (gl_.player.peercast() && layout_.nameRect(rect).PtInRect(point))
		{// |bvAbv\
			CRect rc(org);
			ClientToScreen(&rc);

			channel_.setPosition(rc.left, rc.top);
			channel_.Invalidate(FALSE);
			channel_.ShowWindow(SW_SHOWNA);

			SetCursor(LoadCursor(NULL, IDC_HAND));
			SetMouseHover();
			return;
		}
		else
		{
			SetCursor(LoadCursor(NULL, IDC_ARROW));
			channel_.ShowWindow(SW_HIDE);
		}
	}

	//CDialog::OnMouseMove(nFlags, point);
}


void CStatusDlg::OnMouseLeave()
{
	SetCursor(LoadCursor(NULL, IDC_ARROW));

	if (layout_.slider.enable)
	{
		SetTimer(TIMER_ID_SLIDER, 1000, NULL);// XC_[
	}

	channel_.ShowWindow(SW_HIDE);

	CDialog::OnMouseLeave();
}


void CStatusDlg::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	if (gl_.player.peercast())
	{
		CRect rect;
		GetClientRect(rect);
		rect.DeflateRect(cfg_.marginX, 0);

		if (layout_.nameRect(rect).PtInRect(point))
		{ // _uNbNŃ`lXV
			gl_.peca.info();
		}
	}

	OnLButtonDown(nFlags, point);

	//CDialog::OnLButtonDblClk(nFlags, point);
}


void CStatusDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	SetFocus();

	CRect rect;
	GetClientRect(rect);
	rect.DeflateRect(cfg_.marginX, 0);

	{// {[~[g
		if (layout_.volumeRect(rect).PtInRect(point))
		{
			utl::toggle(gl_.value.audio.mute);
			gl_.player.setMute(gl_.value.audio.mute);
			Invalidate(FALSE);
			UpdateWindow();

			SetCursor(LoadCursor(NULL, IDC_HAND));
			click_ = true;
			return;
		}
	}

	if (!capture_)
	{// {[XC_[
		if (layout_.sliderRect(rect).PtInRect(point))
		{
			SetCapture();
			capture_ = true;
			SetCursor(LoadCursor(NULL, IDC_HAND));
			OnMouseMove(nFlags, point); // ʏϔC
			return;
		}
	}

	{// O
		if (gl_.player.peercast() && layout_.nameRect(rect).PtInRect(point))
		{// O͏ɃnhJ[\
			SetCursor(LoadCursor(NULL, IDC_HAND));
			click_ = true;
			return;
		}
	}


	if (!gl_.value.window.status.fixed)
	{
		if (layout_.time.enable)
		{// ^C
			if (layout_.timeRect(rect).PtInRect(point))
			{
				if (layout_.time.type < 1) { layout_.time.type++; } else { layout_.time.type = 0; }
				gl_.value.format.time.type = layout_.time.type;
				Invalidate(FALSE);
				UpdateWindow();

				SetCursor(LoadCursor(NULL, IDC_HAND));
				click_ = true;
				return;
			}
		}

		if (layout_.size.enable)
		{// TCY
			if (layout_.sizeRect(rect).PtInRect(point))
			{
				if (layout_.size.type < 2) { layout_.size.type++; } else { layout_.size.type = 0; }
				gl_.value.format.size.type = layout_.size.type;
				Invalidate(FALSE);
				UpdateWindow();

				SetCursor(LoadCursor(NULL, IDC_HAND));
				click_ = true;
				return;
			}
		}

		if (layout_.bitrate.enable)
		{// rbg[g
			if (layout_.bitrateRect(rect).PtInRect(point))
			{
				if (layout_.bitrate.type < 3) { layout_.bitrate.type++; } else { layout_.bitrate.type = 0; }
				gl_.value.format.bitrate.type = layout_.bitrate.type;
				Invalidate(FALSE);
				UpdateWindow();

				SetCursor(LoadCursor(NULL, IDC_HAND));
				click_ = true;
				return;
			}
		}

		if (layout_.fps.enable)
		{// fps
			if (layout_.fpsRect(rect).PtInRect(point))
			{
				if (layout_.fps.type < 3) { layout_.fps.type++; } else { layout_.fps.type = 0; }
				gl_.value.format.fps.type = layout_.fps.type;
				Invalidate(FALSE);
				UpdateWindow();

				SetCursor(LoadCursor(NULL, IDC_HAND));
				click_ = true;
				return;
			}
		}
	}

	// eWɕϊ
	ClientToScreen(&point);
	reinterpret_cast<CSubpaneDlg*>(GetParent())->ScreenToClient(&point);
	reinterpret_cast<CSubpaneDlg*>(GetParent())->OnLButtonDown(nFlags, point);

	//CDialog::OnLButtonDown(nFlags, point);
}



void CStatusDlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	if (capture_)
	{
		ReleaseCapture();
		capture_ = false;
	}

	if (click_)
	{
		SetCursor(LoadCursor(NULL, IDC_HAND));
		click_ = false;
	}
	//CDialog::OnLButtonUp(nFlags, point);
}

void CStatusDlg::OnRButtonDown(UINT nFlags, CPoint point)
{
	SetFocus();

	CRect rect;
	GetClientRect(rect);
	rect.DeflateRect(cfg_.marginX, 0);

	{// {[/XC_[\؂ւ
		if ((layout_.slider.enable && layout_.sliderRect(rect).PtInRect(point)) ||
			layout_.volumeRect(rect).PtInRect(point))
		{
			KillTimer(TIMER_ID_SLIDER);// x^C}[Zbg

			gl_.value.format.volume.enable = utl::toggle(layout_.volume.enable);
			layout_.slider.enable = layout_.volume.enable;

			Invalidate(FALSE);
			UpdateWindow();
			SetCursor(LoadCursor(NULL, IDC_HAND));
			click_ = true;
			return;
		}
	}

	{// O
		if (gl_.player.peercast() && layout_.nameRect(rect).PtInRect(point))
		{
			if (!gl_.value.window.status.fixed)
			{
				if (!gl_.value.window.status.channel.name)
				{
					gl_.value.window.status.channel.name = true;
				}
				else if (!gl_.value.window.status.channel.type)
				{
					gl_.value.window.status.channel.type = true;
				}
				else if (
						!gl_.value.window.status.channel.genre ||
						!gl_.value.window.status.channel.comment ||
						!gl_.value.window.status.channel.playing ||
						!gl_.value.window.status.channel.relay
						)
				{
					gl_.value.window.status.channel.genre = true;
					gl_.value.window.status.channel.comment = true;
					gl_.value.window.status.channel.playing = true;
					gl_.value.window.status.channel.relay = true;
				}
				else
				{
					gl_.value.window.status.channel.type = false;
					gl_.value.window.status.channel.genre = false;
					gl_.value.window.status.channel.comment = false;
					gl_.value.window.status.channel.playing = false;
					gl_.value.window.status.channel.relay = false;
				}
				Invalidate(FALSE);
				UpdateWindow();
			}

			// O͏ɃnhJ[\
			SetCursor(LoadCursor(NULL, IDC_HAND));
			click_ = true;
			return;
		}
	}

	if (!gl_.value.window.status.fixed)
	{
		{// ^C
			if (layout_.timeRect(rect).PtInRect(point))
			{
				gl_.value.format.time.enable = utl::toggle(layout_.time.enable);

				Invalidate(FALSE);
				UpdateWindow();

				if (layout_.time.enable)
				{
					SetCursor(LoadCursor(NULL, IDC_HAND));
					click_ = true;
				}
				return;
			}
		}

		{// TCY
			if (layout_.sizeRect(rect).PtInRect(point))
			{
				gl_.value.format.size.enable = utl::toggle(layout_.size.enable);

				Invalidate(FALSE);
				UpdateWindow();

				if (layout_.size.enable)
				{
					SetCursor(LoadCursor(NULL, IDC_HAND));
					click_ = true;
				}
				return;
			}
		}

		{// rbg[g
			if (layout_.bitrateRect(rect).PtInRect(point))
			{
				gl_.value.format.bitrate.enable = utl::toggle(layout_.bitrate.enable);

				Invalidate(FALSE);
				UpdateWindow();

				if (layout_.bitrate.enable)
				{
					SetCursor(LoadCursor(NULL, IDC_HAND));
					click_ = true;
				}
				return;
			}
		}
	
		{// fps
			if (layout_.fpsRect(rect).PtInRect(point))
			{
				gl_.value.format.fps.enable = utl::toggle(layout_.fps.enable);

				Invalidate(FALSE);
				UpdateWindow();

				if (layout_.fps.enable)
				{
					SetCursor(LoadCursor(NULL, IDC_HAND));
					click_ = true;
				}
				return;
			}
		}
	}

	//CDialog::OnRButtonDown(nFlags, point);
}


void CStatusDlg::OnRButtonUp(UINT nFlags, CPoint point)
{
	if (click_)
	{
		SetCursor(LoadCursor(NULL, IDC_HAND));
		click_ = false;
	}
	//CDialog::OnRButtonUp(nFlags, point);
}


void CStatusDlg::OnRButtonDblClk(UINT nFlags, CPoint point)
{
	OnRButtonDown(nFlags, point);

	//CDialog::OnRButtonDblClk(nFlags, point);
}

void CStatusDlg::OnMButtonDown(UINT nFlags, CPoint point)
{
	if (gl_.value.operation.mouse.status.transfer)
	{// ʏ㑀ֈϏ
		// eWɕϊ
		ClientToScreen(&point);
		reinterpret_cast<CSubpaneDlg*>(GetParent())->ScreenToClient(&point);
		reinterpret_cast<CSubpaneDlg*>(GetParent())->OnMButtonDown(nFlags, point);
		return;
	}

	CSubpaneDlg* sub = reinterpret_cast<CSubpaneDlg*>(GetParent());
	if (!sub) { return; }
	CMainDlg* main = reinterpret_cast<CMainDlg*>(sub->GetParent());
	if (!main) { return; }

	main->MouseMClickHelper(gl_.value.operation.mouse.status.mclick);

	//CDialog::OnMButtonDown(nFlags, point);
}
